CREATE TABLE poinIType(
	poinitypeid	VARCHAR(5),
	poinIDesc	VARCHAR(25),
	CONSTRAINT pk_pointype PRIMARY KEY (poinitypeid)
);

INSERT INTO poinIType VALUES('ALL', 'Semua Item');
INSERT INTO poinIType VALUES('GROUP', 'Grup Item');
INSERT INTO poinIType VALUES('BRAND', 'Merk Item');
INSERT INTO poinIType VALUES('ITEM', 'Per-Item');

CREATE TABLE poinTarget(
	poinTargetId	VARCHAR(5),
	poinTarget	VARCHAR(20),
	CONSTRAINT pk_poinTarget PRIMARY KEY (poinTargetId)
);

INSERT INTO poinTarget VALUES('ALL','Semua Customer');
INSERT INTO poinTarget VALUES('GCUST','Grup Customer');


CREATE TABLE PoinCondition(
	poinconditionid VARCHAR(5),
	poincondition 	 VARCHAR(20),
	CONSTRAINT pk_poinCondition PRIMARY KEY (poinconditionid)
);

INSERT INTO poinCondition VALUES('TOTAL','Total Faktur');
INSERT INTO poinCondition VALUES('Qty','Qty Item');

CREATE TABLE poinRule(
	PoinRuleNo	VARCHAR(15),
	PoinRuleDesc	VARCHAR(30),
	startdate	DATE,
	enddate		DATE,
	poinitypeid	VARCHAR(5), ---Berdasarkan Semua Item,Grup Item,Merk Item,Per-Item
	itgrpid		VARCHAR(10),---Muncul bila yang dipilih berdasarkan grup item		
	brandid		VARCHAR(10),---Muncul bila yang dipilih berdasarkan merk item
	itemid		VARCHAR(20),---Muncul bila yang dipilih berdasarkan per-item 
	poinconditionid VARCHAR(5), ---kondisi perolehan poin, total faktur atau qty item
	ismultiple	BOOLEAN DEFAULT TRUE, ---berlaku kelipatanya atau tidak
	poinTargetId	VARCHAR(5), ---Berlaku ke semua customer atau grup tertentu
	bpgrpid		VARCHAR(10), ---Muncul bila diisi per grup customer tertentu
	QtyPoin		NUMERIC(19,4) DEFAULT 0,
	aktive		BOOLEAN DEFAULT TRUE,
	CONSTRAINT pk_poinrule PRIMARY KEY (PoinRuleNo),
	CONSTRAINT fk_poinrule_RELATIONS_pointitype foreign key (poinitypeid) references poinIType (poinitypeid) ON DELETE RESTRICT,
	CONSTRAINT fk_poinrule_RELATIONS_itgrp foreign key (itgrpid) references itgrp (itgrpid) ON DELETE RESTRICT,
	CONSTRAINT fk_poinrule_RELATIONS_brand foreign key (brandid) references brand (brandid) ON DELETE RESTRICT,
	CONSTRAINT fk_poinrule_RELATIONS_item foreign key (itemid) references item (itemid) ON DELETE RESTRICT,
	CONSTRAINT fk_poinrule_RELATIONS_poincondition foreign key (poinconditionid) references poincondition (poinconditionid) ON DELETE RESTRICT,
	CONSTRAINT fk_poinrule_RELATIONS_bpgrp foreign key (bpgrpid) references bpgrp (bpgrpid) ON DELETE RESTRICT,
	CONSTRAINT fk_poinrule_RELATIONS_pointarget foreign key (pointargetid) references pointarget (pointargetid) ON DELETE RESTRICT

);


CREATE UNIQUE INDEX poinrule_PK on poinrule (
poinruleno
);


CREATE TABLE poin(
	poinno		VARCHAR(15),
	custid		VARCHAR(15),
	poindate	DATE,
	reftype		VARCHAR(10), --- SALE
	TotalPoin	NUMERIC(15,4),
	CONSTRAINT pk_poin PRIMARY KEY (PoinNo),
	CONSTRAINT fk_poin_RELATIONS_bp foreign key (custid) references bp (bpid) ON DELETE RESTRICT
);

CREATE UNIQUE INDEX poin_PK on poin (
poinno
);

CREATE TABLE poind(
	poinno		VARCHAR(15),
	poindno		SMALLINT,
	poincode	VARCHAR(15), ---Sesuai dengan kode bundle
	poinName	VARCHAR(50), ---Sesuai dengan nama bundle
	qtypoin		NUMERIC(15,4),
	expaired	DATE,
	CONSTRAINT pk_poind PRIMARY KEY (PoinNo,PoinDno)
);

CREATE UNIQUE INDEX poind_pk on poind (
poinno,poindno
);

ALTER TABLE poind ADD poinmodul VARCHAR(25);


CREATE TABLE poinsale(
	poinno		VARCHAR(15),
	saleno	VARCHAR(15)
	--CONSTRAINT fk_poinsale_RELATIONS_poin foreign key (poinno) references poin (poinno) ON DELETE RESTRICT,
	--CONSTRAINT fk_poinsale_RELATIONS_sale foreign key (saleno) references sale (saleno) ON DELETE RESTRICT
);

CREATE TABLE redim
(
  redimno character varying(15) NOT NULL,
  custid character varying(15),
  redimdate date,
  totalusepoin numeric(19,4) DEFAULT 0,
  redimnote character varying(15),
  crtby character varying(10),
  crtdate date,
  updby character varying(10),
  upddate date,
  empid character varying(15),
  branchid character varying(5),
  CONSTRAINT pk_redim PRIMARY KEY (redimno)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE redim OWNER TO bits;


CREATE TABLE redimd
(
  redimno character varying(15) NOT NULL,
  redimdno smallint NOT NULL,
  modulid character varying(20),
  poinmodul character varying(25),
  poincode character varying(15),
  poinname character varying(50),
  qty numeric(15,4) DEFAULT 0,
  redimdnote text,
  CONSTRAINT pk_redimd PRIMARY KEY (redimno, redimdno)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE redimd OWNER TO bits;

create table POINSTOCK (
POINMODUL	     VARCHAR          not null,
POINRULENO           VARCHAR(15)      not null,
BPID                 VARCHAR(15)      not null,
QTY                  DECIMAL(15,4)        null,
ACTIVE		     BOOLEAN,
constraint PK_POINSTOCK primary key (Poinmodul,poinruleno,bpid),
constraint FK_POIN_STOCK_REL_BP foreign key (BPID) references BP (BPID) on delete restrict on update restrict
);

create table POINCARD (
CARDNO               VARCHAR(15)          not null,
POINMODUL	     	 VARCHAR	          not null,
POINRULENO	     	 VARCHAR(15)      	  not null,	
BPID                 VARCHAR(15)          not null,
CARDDATE             DATE                 null,
CARDQTY              DECIMAL(15,4)        null,
REFNO                VARCHAR(15)          null,
REFTYPE              VARCHAR(5)           null,
constraint PK_PREPAIDCARD primary key (CARDNO),
constraint FK_PREPAIDC_PPCARD_RE_BP foreign key (BPID) references BP (BPID) on delete restrict on update restrict
);

CREATE TABLE poinbal
(
  modulname character varying(20) NOT NULL,
  ruleno character varying(25) NOT NULL,
  bpid character varying(15) NOT NULL,
  pyear integer NOT NULL,
  stockbal00 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal01 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal02 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal03 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal04 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal05 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal06 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal07 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal08 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal09 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal10 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal11 numeric(15,4) NOT NULL DEFAULT 0,
  stockbal12 numeric(15,4) NOT NULL DEFAULT 0,
  CONSTRAINT pk_poinbal PRIMARY KEY (modulname, ruleno, bpid, pyear),
  CONSTRAINT fk_ppbal_re_poinrule FOREIGN KEY (ruleno)
      REFERENCES poinrule (poinruleno) MATCH SIMPLE
      ON UPDATE RESTRICT ON DELETE RESTRICT,
  CONSTRAINT fk_ppbal_re_bp FOREIGN KEY (bpid)
      REFERENCES bp (bpid) MATCH SIMPLE
      ON UPDATE RESTRICT ON DELETE RESTRICT
)
WITH (
  OIDS=FALSE
);
ALTER TABLE poinbal OWNER TO bits;

-- Index: prepaidbal_pk

-- DROP INDEX prepaidbal_pk;

CREATE UNIQUE INDEX poinbal_pk
  ON poinbal
  USING btree
  (modulname, ruleno, bpid, pyear);

-- Table: poinsret

-- DROP TABLE poinsret;

CREATE TABLE poinsret
(
  poinno character varying(15) NOT NULL,
  sretno character varying(15) NOT NULL,
  CONSTRAINT pk_poinsret PRIMARY KEY (poinno, sretno)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE poinsret OWNER TO bits;

CREATE TABLE padj
(
	padjno character varying(15) NOT NULL,
	padjdate DATE,
	padjtype character varying(5),
	bpid character varying(15),
	branchid character varying(5),
	padjnote text,
	crtby character varying(10),
	crtdate timestamp without time zone,
	updby character varying(10),
	upddate timestamp without time zone,
	CONSTRAINT pk_padj PRIMARY KEY (padjno)
)
WITH (
	OIDS=FALSE
);
ALTER TABLE padj OWNER TO bits;

CREATE TABLE padjd
(
	padjno character varying(15) NOT NULL,
	padjdno smallint NOT NULL,
	modulid character varying(20),
	poinmodul character varying(25),
	poincode character varying(15),
	poinname character varying(50),
	qty numeric(15,4) DEFAULT 0,
	CONSTRAINT pk_padjd PRIMARY KEY (padjno, padjdno)
)
WITH (
	OIDS=FALSE
);

ALTER TABLE padjd OWNER to bits;

INSERT INTO NCOUNT (noid,transcode,curno,nolen) VALUES('REDIMTRANS','RD',1000,6);
INSERT INTO NCOUNT (noid,transcode,curno,nolen) VALUES('POINCARD','PC',1000,6);
INSERT INTO NCOUNT (noid,transcode,curno,nolen) VALUES('POINRULE', 'PR', 1000,6);
INSERT INTO NCOUNT (noid,transcode,curno,nolen) VALUES('POINTRANS','PN',1000,6);
INSERT INTO NCOUNT (noid,transcode,curno,nolen) VALUES('PADJ', 'PA', 1000,8);
ALTER TABLE poinrule ADD totalsale NUMERIC(19,4);
ALTER TABLE poinrule ADD qtysale NUMERIC(15,4);
ALTER TABLE poinrule ADD crcid VARCHAR (5);
ALTER TABLE poind ADD poinmodul VARCHAR(25);
ALTER TABLE poind ADD poindate DATE;
ALTER TABLE poin ADD refno VARCHAR(15);
ALTER TABLE redimd ALTER COLUMN redimdnote TYPE text;
ALTER TABLE poinsale DROP CONSTRAINT fk_poinsale_relations_poin;
ALTER TABLE poinsale DROP CONSTRAINT fk_poinsale_relations_sale;
CREATE TYPE cekpoin AS(
	bpid 		VARCHAR,
	poinmodul 	VARCHAR,
	total		NUMERIC
);

CREATE OR REPLACE FUNCTION fcekpoin(_bpid character varying)
  RETURNS SETOF cekpoin AS
$BODY$
DECLARE
	_retval		cekpoin%ROWTYPE;
	_VBpId		VARCHAR(15);
	_PoinModul	VARCHAR(25);
	_BpName 	VARCHAR(50);
	_Addr		VARCHAR(255);
	_ContName	VARCHAR(50);
	_Mobile		VARCHAR(30);
	_Total 		NUMERIC(15,4);
	
	CPoinCek	REFCURSOR;
	
BEGIN

	_retval.bpid := _BpId;
	_retval.poinmodul:=NULL;
	_retval.total:=NULL;
	SELECT INTO _BpName bpname FROM bp WHERE bpid = _BpId;
	SELECT INTO _Addr addr FROM addr WHERE bpid = _BpId;
	SELECT INTO _ContName contname FROM cont WHERE bpid = _BpId;
	SELECT INTO _Mobile mobile FROM cont WHERE bpid = _BpId;
		
	
	OPEN CPoinCek FOR
	
			/* SELECT bp.bpid, poinmodul, SUM(qty) as Total FROM poinstock 
			JOIN bp ON poinstock.bpid = bp.bpid 
			WHERE bp.bpid=_BpId AND bp.bpname=_BpName
			GROUP BY bp.bpid,poinmodul; */
		
		/* IF NOT EXISTS (SELECT 1 FROM addr WHERE bpid=_BpId) THEN
		
			SELECT bp.bpid, poinmodul, SUM(qty) as Total FROM poinstock 
			JOIN bp ON poinstock.bpid = bp.bpid 
			WHERE bp.bpid=_BpId AND bp.bpname=_BpName
			GROUP BY bp.bpid,poinmodul;
			
		ELSE*/
		
			
			SELECT bp.bpid, poinmodul, SUM(qty) as Total FROM poinstock 
			JOIN bp ON poinstock.bpid = bp.bpid 
			JOIN addr ON bp.bpid=addr.bpid 
			JOIN cont ON bp.bpid=cont.bpid 
			WHERE bp.bpid=_BpId AND bp.bpname=_BpName
			AND addr.addr=_Addr AND cont.contname=_ContName
			AND cont.mobile=_Mobile GROUP BY bp.bpid,poinmodul;
	
		/* END IF; */
	LOOP
		FETCH CPoinCek INTO _VBpId, _PoinModul, _Total;
		EXIT WHEN NOT FOUND;
		
		RETURN NEXT _retval;
		
		_retval.bpid := _VBpId;
		_retval.poinmodul := _PoinModul;
		_retval.total := _Total;
		
	END LOOP;
	CLOSE CPoinCek;
	
	RETURN NEXT _retval;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION fcekpoin(character varying)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION fpoinbal_startdate(_modulname character varying, _poincode character varying, _bpid character varying, _date date)
  RETURNS numeric AS
$BODY$
DECLARE
	_LastMonthBal	NUMERIC(15,4);
	_YesterdayBal	NUMERIC(15,4);
	_Saldo		NUMERIC(15,4);
 
BEGIN
	_LastMonthBal:=COALESCE(fPoinBal_StartMonth(_modulname, _PoinCode, _BPID, _Date), 0);
	SELECT INTO _YesterdayBal COALESCE(sum((CASE WHEN reftype='RDM' THEN (-1*cardqty) ELSE cardqty END)), 0)
        FROM poincard WHERE bpid = _BPID AND poinmodul=_modulname AND poinruleno=_poincode AND carddate >= fBegOfMonth(_Date) AND Carddate < _Date;

	_Saldo := _LastMonthBal + _YesterdayBal;  
			
	IF (_Saldo IS NULL) THEN
		_Saldo:=0;
	END IF;

	RETURN _Saldo;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION fpoinbal_startdate(character varying, character varying, character varying, date)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION fpoinbal_startmonth(_poinmodul character varying, _poincode character varying, _bpid character varying, _startdate date)
  RETURNS numeric AS
$BODY$
DECLARE
	_retval		NUMERIC(15,4);

	_Month		INT;
	_PYear		INT;
BEGIN
	SELECT INTO _Month * FROM date_part('month', CAST(_StartDate AS DATE));
	SELECT INTO _PYear * FROM date_part('year', CAST(_StartDate AS DATE));

	IF (_Month IS NULL) THEN
		_Month:=0;
	ELSE
		_Month:=_Month-1;
	END IF;
	
	SELECT INTO _retval SUM(fPoinStockDate_Qty(poinmodul, _Month, _PYear, _BPID, _poincode))
	FROM (SELECT DISTINCT poinmodul FROM poinstock WHERE poinmodul = _poinmodul AND bpid=_BPID AND poinruleno=_poincode) as qty;

	RETURN COALESCE(_retval, 0);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION fpoinbal_startmonth(character varying, character varying, character varying, date)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION fpoinstockdate_qty(_poinmodul character varying, _month integer, _pyear integer, _bpid character varying, _poincode character varying)
  RETURNS numeric AS
$BODY$
DECLARE
	_retval		NUMERIC(15,4);
	_MaxYear	INT;
	_VBpId		bp.bpid%TYPE;

	_TotalBal	NUMERIC(15,4);
	cBal		REFCURSOR;
BEGIN
	/** inisialisasi */
	_retval:=0;

	OPEN cBal FOR
		SELECT MAX(pyear) 
		FROM poinbal b join poinstock s on b.ruleno = s.poinruleno  
		WHERE b.modulname=_poinmodul AND s.bpid= _BpId;
	
	LOOP
		FETCH cBal INTO _MaxYear;
		EXIT WHEN NOT FOUND;

		IF (_MaxYear<_PYear) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)+COALESCE(stockbal08, 0)+COALESCE(stockbal09, 0)+COALESCE(stockbal10, 0)+COALESCE(stockbal11, 0)+COALESCE(stockbal12, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
			CONTINUE;
		END IF;

		IF (_Month=0) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;
			
			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=1) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=2) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=3) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;
				
			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=4) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=5) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=6) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=7) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=8) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)+COALESCE(stockbal08, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=9) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)+COALESCE(stockbal08, 0)+COALESCE(stockbal09, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=10) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)+COALESCE(stockbal08, 0)+COALESCE(stockbal09, 0)+COALESCE(stockbal10, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=11) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)+COALESCE(stockbal08, 0)+COALESCE(stockbal09, 0)+COALESCE(stockbal10, 0)+COALESCE(stockbal11, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;

			_retval:=_retval+COALESCE(_TotalBal, 0);
		ELSIF (_Month=12) THEN
			SELECT INTO _TotalBal SUM(COALESCE(stockbal00, 0)+COALESCE(stockbal01, 0)+COALESCE(stockbal02, 0)+COALESCE(stockbal03, 0)+COALESCE(stockbal04, 0)+COALESCE(stockbal05, 0)+COALESCE(stockbal06, 0)+COALESCE(stockbal07, 0)+COALESCE(stockbal08, 0)+COALESCE(stockbal09, 0)+COALESCE(stockbal10, 0)+COALESCE(stockbal11, 0)+COALESCE(stockbal12, 0)) AS qty 
			FROM poinbal b join poinstock s on b.ruleno = s.poinruleno
			WHERE b.modulname=_poinmodul AND s.bpid= _BpId AND s.poinruleno= _poincode;
	
			_retval:=_retval+COALESCE(_TotalBal, 0);
		END IF;
	END LOOP;
	CLOSE cBal;

	RETURN _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION fpoinstockdate_qty(character varying, integer, integer, character varying, character varying)
  OWNER TO bits;

CREATE TYPE poinstockrpt AS
   (cardno character varying,
    bpid character varying,
    poinmodul character varying,
    carddate date,
    reftype character varying,
    refno character varying,
    debet character varying,
    debetval numeric(15,4),
    kredit character varying,
    kreditval numeric(15,4),
    stockanote character varying,
    poinbal numeric(15,4),
    stockbal character varying);
ALTER TYPE poinstockrpt
  OWNER TO bits;


-- Function: frekappoinstockcard(character varying, character varying, character varying, date, date)

-- DROP FUNCTION frekappoinstockcard(character varying, character varying, character varying, date, date);

CREATE OR REPLACE FUNCTION frekappoinstockcard(_poinmodul character varying, _poincode character varying, _bpid character varying, _startdate date, _enddate date)
  RETURNS SETOF poinstockrpt AS
$BODY$
DECLARE
	_retval			poinstockrpt%ROWTYPE;
	_Cardno			VARCHAR(15);
	_ModulName		VARCHAR(25);
	_VBPid			VARCHAR(15);
	_CardDate		DATE;
	_RefType		VARCHAR(5);
	_RefNo			VARCHAR(15);
	_PoinBal		NUMERIC(15,4);
	_Qty			NUMERIC(15,4);
	_Unit			VARCHAR(5);
	_Debet  		NUMERIC(15,4);
	_Kredit  		NUMERIC(15,4);
	_QtyUnit1		NUMERIC(15,4);
	_YesterdayBal	NUMERIC(15,4);
	
	
	cPoinCard		REFCURSOR;
BEGIN
	
	_YesterdayBal:=fPoinBal_StartDate(_PoinModul,_PoinCode, _Bpid, _StartDate);
	_PoinBal:=_YesterdayBal;
	
	_retval.cardno :=NULL;
	_retval.bpid :=_BPID;
	_retval.poinmodul := _PoinModul;
	_retval.carddate:=_StartDate;
	_retval.reftype:=NULL;
	_retval.refno:=NULL;
	_retval.debet:=NULL;
	_retval.kredit:=NULL;
	_retval.debetval:=NULL;
	_retval.kreditval:=NULL;
	_retval.stockanote:='Saldo';
	_retval.poinbal:=_PoinBal;
	_retval.stockbal:=_PoinBal;

	--RETURN NEXT _retval; 

	OPEN cPoinCard FOR
	       SELECT cardno,bpid,poinmodul, carddate, refno, reftype, (CASE WHEN reftype='SALE' THEN cardqty WHEN reftype='BEG' THEN cardqty ELSE null END) AS debet, 
	       (CASE WHEN reftype!='SALE' AND reftype!='BEG' THEN cardqty ELSE null END) AS kredit, 
	       SUM(CASE WHEN reftype='RDM' OR reftype='SRET' THEN (-1*cardqty) ELSE cardqty END) AS realqty
               FROM poincard Where bpid = _BPID AND poinmodul=_PoinModul AND poinruleno=_Poincode AND carddate >= _StartDate AND carddate <= _EndDate
               GROUP BY cardno,bpid,poinmodul, carddate, refno, reftype, cardqty;

	LOOP
		FETCH cPoinCard INTO _Cardno,_VBPid, _ModulName, _CardDate, _RefNo,_RefType,_Debet,_Kredit, _QtyUnit1;
		EXIT WHEN NOT FOUND;

		RETURN NEXT _retval;
		_PoinBal := _PoinBal+_QtyUnit1;
		
		_retval.cardno := _Cardno;
		_retval.bpid :=_VBPID;
		_retval.poinmodul := _ModulName;
		_retval.carddate:=_CardDate;
		_retval.reftype:=_RefType;
		_retval.refno:=_RefNo;
		_retval.debetval:=_Debet;
		_retval.kreditval:=_Kredit;
		_retval.poinbal:=_PoinBal;

		IF (_Debet > 0) THEN
		   _retval.debet:=_Debet;
		ELSE 
		   _retval.debet:=NULL;	
		END IF;

		IF (_Kredit > 0) THEN
		     _retval.kredit:=_Kredit;
		ELSE
		     _retval.kredit:=NULL;
		END IF;

		IF (_RefType = 'RDM') THEN 
		       _retval.stockanote:= 'Penggunaan #'||_RefNo||' ';
		ELSEIF (_RefType = 'SRET') THEN 
		       _retval.stockanote:= 'Retur #'||_RefNo||' ';
		ELSEIF (_RefType = 'SALE') THEN
			_retval.stockanote:='Pembelian #'||_RefNo||' ';
		ELSE 
			_retval.stockanote:='Set Saldo Awal';
		END IF;

		IF(_PoinBal=0)THEN
			_retval.stockbal:=0;
		ELSE
			_retval.stockbal:=_PoinBal;
		END IF;
	END LOOP;
	CLOSE cPoinCard;

	RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION frekappoinstockcard(character varying, character varying, character varying, date, date) OWNER TO bits;


CREATE OR REPLACE FUNCTION sppoinbal_update(__modulname character varying, __ruleno character varying, _bpid character varying, __qty numeric, __stockadate date)
  RETURNS SETOF spstatus AS
$BODY$


DECLARE
	_retval		SPStatus%ROWTYPE;

	
	_IsStock	BOOLEAN;
	_curQty		NUMERIC(15,4);
	_curQtyX	NUMERIC(15,4);
	_curAvgCost	NUMERIC(19,4);
	_newQty		NUMERIC(15,4);
	_newQtyX	NUMERIC(15,4);
	_newAvgCost	NUMERIC(19,4);		
	_IsEmpty	BOOLEAN;
	_Cost1		NUMERIC(19,4);		
	_Qty_Unit1	NUMERIC(15,4);
	_Month		INT2;
	_PYear		INT4;
	_fPYear		INT4;
	_BegBal		NUMERIC(15,4);
	_Cost		NUMERIC(19,4);
	_PID		VARCHAR(25);
	_StockGuard	BOOLEAN;

	_OpDate		DATE;	
	_OpEmpID	VARCHAR;
	_OpUsrID	VARCHAR;
	_OpNote		VARCHAR;

	_Count		INT;
	
	cFutureStockBal refcursor;
	_usePID			BOOLEAN;
	_isPIDUnique	BOOLEAN;
BEGIN


		/** praduga bersalah **/
		_retval.ErrNo:=1;
		_retval.ErrMsg:='General Error in spStockBal_Update';
		
		
		/*** Get Current Stock ***/
		SELECT INTO _curQty Qty
		FROM PoinStock 
		WHERE poinmodul = __ModulName AND poinruleno=__RuleNo AND bpid=_BpID;
		
		
		IF NOT FOUND THEN
			
			/** anak baru ? kasian deh ... kasih data awal dunk! **/
			_curQty:=0;						
		END IF;

		/** convert ke Qty1 (qty dasar) ***/
		--_Qty_Unit1:=__Qty*__Conv;
		_Qty_Unit1:=__Qty;

		IF (_Qty_Unit1 IS NULL) THEN
			_retval.ErrNo:=50006;
			_retval.ErrMsg:='Error Konversi Item:'||__prepaiditemid||' Unit:'||__prepaidtrxno||' (spStockBal_Update)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		_newQty:=_curQty+_Qty_Unit1;

	       	
		--RAISE EXCEPTION 'curQty:%', _curQty;
		


		IF (_newQty<0) THEN
			IF (_usePID AND _isPIDunique) THEN
				_retval.ErrNo:=50007;
				_retval.ErrMsg:='Stock Item:'||__itemid||' tidak mencukupi (atau kosong) untuk transaksi ini (spStockBal_Update)';
				RAISE EXCEPTION '%', _retval.ErrMsg;								
			ELSE
				_IsEmpty:=true;							
			END IF;
		ELSE
			_IsEmpty:=false;
		END IF;

		/** DEBUG		
		RAISE NOTICE 'newQty:%', _newQty;
		*/



		/*Cek Reg ngambil STOCK_GUARD*/
		SELECT INTO _StockGuard regval FROM reg WHERE regid='STOCK_GUARD';

		IF((_StockGuard='1') AND (_newQty<0)) THEN
			_retval.ErrNo:=50005;
			_retval.ErrMsg:='Stock modulname:'||__ModulName||' Qty tidak boleh minus (spStockBal_Update)!!';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		--_OpDate:=to_date(__StockADate,'YYYY-MM-DD');
		_OpDate:=__StockADate;

		

		--UPDATE PrepaidStock SET Qty=_newQty
		--WHERE modulname=__ModulName AND ruleno = __RuleNo;


		SELECT INTO _PYear CAST(date_part('year', __StockADate) AS VARCHAR);
		SELECT INTO _Month CAST(date_part('month',  __StockADate ) AS VARCHAR);

		/*** Check Current Year StockBal is EXIST!
		**** NO ? -> create one *****/

		IF NOT EXISTS (SELECT 1 FROM poinBal WHERE modulname=__ModulName AND bpid=_BpID AND ruleno=__ruleno AND PYear=_PYear) THEN 
			SELECT INTO _BegBal (StockBal00+StockBal01+StockBal02+StockBal03+StockBal04+StockBal05+StockBal06+StockBal07+StockBal08+StockBal09+StockBal10+StockBal11+StockBal12)
			FROM poinBal WHERE modulname=__ModulName AND ruleno=__RuleNo AND bpid=_BpID 
			AND PYear=(SELECT MAX(PYear) FROM poinBal WHERE modulname=__ModulName AND ruleno=__RuleNo AND PYear<_PYear);

			/*** Jika belum ada Saldo Tahun sebelumnya, SaldoAwal:=0 ***/
			IF NOT FOUND THEN
			 _BegBal:=0;
			END IF;

			INSERT INTO poinBal(modulname, ruleno, bpid, PYear, StockBal00) 
			VALUES (__ModulName, __RuleNo, _BpID, _PYear, _BegBal);

			_retval.ErrMsg:='Error INSERT PrepaidBal for Year:'||CAST(_PYear AS VARCHAR(4))||', ItemID:'||__ModulName||', PrepaidTrxNo:'||__RuleNo||' (spStockBal_Update)';
			
			IF NOT FOUND THEN
				_retval.ErrMsg:='Error INSERT StockBal for Year:'||CAST(_PYear AS VARCHAR(4))||', ItemID:'||__ModulName||', PrepaidTrxNo:'||__RuleNo||' (spStockBal_Update)';
			END IF;
		END IF;

		IF (_Month=1) THEN
			UPDATE poinBal SET StockBal01=StockBal01+_Qty_Unit1 WHERE modulname = __ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=2) THEN
			UPDATE poinBal SET StockBal02=StockBal02+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=3) THEN
			UPDATE poinBal SET StockBal03=StockBal03+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=4) THEN
			UPDATE poinBal SET StockBal04=StockBal04+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=5) THEN
			UPDATE poinBal SET StockBal05=StockBal05+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=6) THEN
			UPDATE poinBal SET StockBal06=StockBal06+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=7) THEN
			UPDATE poinBal SET StockBal07=StockBal07+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=8) THEN
			UPDATE poinBal SET StockBal08=StockBal08+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=9) THEN
			UPDATE poinBal SET StockBal09=StockBal09+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=10) THEN
			UPDATE poinBal SET StockBal10=StockBal10+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo  AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=11) THEN
			UPDATE poinBal SET StockBal11=StockBal11+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		ELSIF (_Month=12) THEN
			UPDATE poinBal SET StockBal12=StockBal12+_Qty_Unit1 WHERE modulname=__ModulName AND ruleno = __RuleNo AND bpid = _BpID AND PYear=_PYear;

		END IF;

		IF NOT FOUND THEN
			_retval.ErrNo:=50016;
			_retval.ErrMsg:='Error UPDATE StockBal for Year:'||CAST(_PYear AS VARCHAR(4))||' Month:'||CAST(_Month AS VARCHAR(2))||' (spStockBal_Update)';
			RAISE EXCEPTION '%', _retval.ErrMsg;				
		END IF;

		OPEN cFutureStockBal FOR
			SELECT PYear FROM poinBal WHERE modulname=__ModulName AND bpid = _BpID  AND ruleno = __RuleNo AND PYear>_PYear;

		LOOP
			FETCH cFutureStockBal INTO _fPYear;
			IF NOT FOUND THEN
				EXIT;
			END IF;

			UPDATE poinBal SET StockBal00=StockBal00+_Qty_Unit1 WHERE modulname=__ModulName AND bpid = _BpID AND ruleno = __RuleNo AND PYear=_fPYear;
			IF NOT FOUND THEN
				_retval.ErrNo:='50017';
				_retval.ErrMsg:='Error UPDATE future StockBal:StockBal00 for Year:'||CAST(_fPYear AS VARCHAR(4))||' (spStockBal_Update)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;		
		END LOOP;
		CLOSE cFutureStockBal;
		
		_retval.ErrNo:=0;
		_retval.ErrMsg:='OK';


RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoinbal_update(character varying, character varying, character varying, numeric, date)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoinstock_new(_poinno character varying, _poindno smallint, _modulname character varying, _bpid character varying, _qty integer, _poincode character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_RuleNo			VARCHAR(15);
	_RefNo			VARCHAR(15);
	_StockQty		DECIMAL(15,4);
	_PriceTotal		DECIMAL(19,4);
	_PriceUnit		DECIMAL(19,4);
	_PoinDate		DATE;
	_Index			INTEGER;

BEGIN
	_retval:=(0, 'OK');
	_Index := 1; 

			SELECT INTO _StockQty qtypoin FROM poind JOIN poin ON poind.poinno=poin.poinno WHERE poinmodul = _ModulName AND custid = _Bpid AND poincode = _PoinCode;
			SELECT INTO _PoinDate poindate FROM poind WHERE poinno=_PoinNo;
			INSERT INTO PoinStock(PoinModul,PoinRuleNo,bpid, qty, active) 
			Values(_ModulName,_PoinCode,_Bpid,_StockQty,True);

			SELECT INTO _spret * FROM spPoinBal_Update(_ModulName,_PoinCode,_Bpid,_StockQty,_PoinDate); 
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

			
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoinstock_new(character varying, smallint, character varying, character varying, integer, character varying)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoinstock_update(_modulname character varying, _bpid character varying, _poicode character varying, _qty numeric, _poindate date)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_RuleNo		    	VARCHAR(15);
	_StockQty		DECIMAL(15,4);
	_SumStockQty		Decimal(15,4);
	_PriceTotal		DECIMAL(19,4);
	_PriceUnit		DECIMAL(19,4);
	_Sisa			DECIMAL(15,4);
	_Index			INTEGER;
	cPoinStock 		REFCURSOR;

BEGIN
	_retval:=(0, 'OK');

	SELECT INTO _SumStockQty sum(qty) 
	FROM PoinStock 
	WHERE bpid=_Bpid AND poinmodul = _ModulName AND poinruleno=_PoiCode AND Qty >= 0;

	
	_Sisa := _Qty;
	OPEN cPoinStock FOR

		SELECT poinruleno, qty 
		FROM PoinStock 
		WHERE bpid=_Bpid AND poinmodul = _ModulName AND poinruleno=_PoiCode AND Qty >= 0
		ORDER BY bpid, poinmodul, poinruleno asc;


		LOOP
		     FETCH cPoinStock INTO _RuleNo, _StockQty;
		     EXIT WHEN NOT FOUND;

		     SELECT INTO _spret * FROM spPoinBal_Update(_ModulName,_RuleNo,_Bpid,-1*_Sisa,_PoinDate); 
		        	IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

		    IF((_StockQty-_Sisa)=0) THEN 
				UPDATE PoinStock SET active=false
		    	 WHERE bpid=_Bpid AND poinmodul = _ModulName AND poinruleno=_PoiCode;
		    END IF;

	           IF((_StockQty-_Sisa)>0) THEN 
				UPDATE PoinStock SET active=true
		    	 WHERE bpid=_Bpid AND poinmodul = _ModulName AND poinruleno=_PoiCode;
		    END IF;


		    
		    IF((_StockQty-_Sisa)<0) THEN
	   		_retval.ErrNo:=50001;
           		_retval.ErrMsg:='Sisa saldo poin kurang dari penggunaan';
	   		RAISE EXCEPTION '%', _retval.ErrMsg;
		    END IF;

			
		    UPDATE PoinStock SET qty=_StockQty-_Sisa
		    WHERE bpid=_Bpid AND poinmodul = _ModulName AND poinruleno=_PoiCode AND Qty >= 0;
			
			
			/*
		     IF (_sisa > _StockQty) THEN 

			SELECT INTO _spret * FROM spPoinBal_Update(_ModulName,_RuleNo,_Bpid,-1*_StockQty,_PoinDate); 
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			UPDATE PoinStock SET qty=0 WHERE PoinRuleNo=_RuleNo;
			UPDATE PoinStock SET active=false WHERE PoinRuleNo=_RuleNo;
			_Sisa := _Sisa-_StockQty;
		     ELSE 
			SELECT INTO _spret * FROM spPoinBal_Update(_ModulName,_RuleNo,_Bpid,-1*_Sisa,_PoinDate); 
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			UPDATE PoinStock SET qty=_StockQty-_Sisa WHERE PoinRuleNo=_RuleNo;			
			_Sisa:=0;
		     END IF;

		     EXIT WHEN _Sisa=0;
*/
		     
		END LOOP;
	CLOSE cPoinStock;
	
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoinstock_update(character varying, character varying, character varying, numeric, date)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoin_new(_poinno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE    
    _retval        SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	
	_ModulName		VARCHAR(25);
	__ruleno		VARCHAR(15);
	_CustId			VARCHAR(15);
	_RefNo			VARCHAR;
	
    cCursor        REFCURSOR;
BEGIN
		
		SELECT INTO _RefNo refno FROM poin WHERE poinno = _PoinNo;
		SELECT INTO _CustId custid FROM poin WHERE poinno = _PoinNo;
		SELECT INTO _ModulName poinmodul FROM poind WHERE poinno = _PoinNo;
		SELECT INTO __ruleno poincode FROM poind WHERE poinno = _PoinNo;
		
		INSERT INTO poinsale (poinno, saleno) VALUES (_PoinNo,_RefNo);

		SELECT INTO _spret * FROM spPoinCard_New(_PoinNo, 'NEW'); 
		       IF _spret.ErrNo<>0 THEN
			  _retval.ErrNo:=_spret.ErrNo;
			  _retval.ErrMsg:=_spret.ErrMsg;
			  RAISE EXCEPTION '%', _retval.ErrMsg;
		      END IF;
		
	_retval:=(0,'OK');
    RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoin_new(character varying)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoin_voidfromsale(_saleno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE    
    _retval        SPStatus%ROWTYPE;
		_spret			SPStatus%ROWTYPE;
	_PoinNo					VARCHAR;
	
    cCursor        REFCURSOR;
BEGIN

		SELECT INTO _PoinNo poinno FROM poinsale WHERE saleno = _SaleNo;

		SELECT INTO _spret * FROM spPoinCard_Void(_PoinNo); 
		      IF _spret.ErrNo <> 0 THEN
			  _retval.ErrNo:=_spret.ErrNo;
			  _retval.ErrMsg:=_spret.ErrMsg;
			  RAISE EXCEPTION '%', _retval.ErrMsg;
		      END IF;
		
		DELETE FROM poinsale WHERE poinno = _PoinNo;
		DELETE FROM poind WHERE poinno = _PoinNo;
		DELETE FROM poin WHERE poinno = _PoinNo;
		
		
		
    _retval:=(0,'OK');
    RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoin_voidfromsale(character varying)
  OWNER TO bits;

-- Function: spredeem_new(character varying)

-- DROP FUNCTION spredeem_new(character varying);

CREATE OR REPLACE FUNCTION spredeem_new(_redimno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_Poinmodul		VARCHAR(25);
	_SaleNo			VARCHAR(15);
	_PoinName		VARCHAR(50);
    _RuleNo			VARCHAR(20);
	_Bpid			VARCHAR(15);
	_RefNo			VARCHAR(15);
	_RefType			VARCHAR(10);
	_PoinNo	    VARCHAR(15);
	_CardNo			VARCHAR(15);
	_PoinCode	    VARCHAR(15);
	_RedimDNo		SMALLINT;
	_Qty			NUMERIC(15,4);
	_StockQty		NUMERIC(15,4);
	_Unit			VARCHAR(5);
	_Conv		        DECIMAL(15,4);
	_RedimDate		DATE;
	_Expired		DATE;
	cRedimD 			REFCURSOR;
	

BEGIN
	_retval:=(0, 'OK');

	
	   OPEN cRedimD FOR
		SELECT  redimdno, poinmodul, poincode, poinname, qty, custid, redimdate
		FROM redimd JOIN redim ON redimd.redimno = redim.redimno
		WHERE redimd.redimno = _Redimno;
		
		LOOP
		FETCH cRedimD INTO _RedimDNo, _PoinModul, _PoinCode, _PoinName, _Qty, _Bpid, _RedimDate;
		EXIT WHEN NOT FOUND;
				
				_RefNo :=	_Redimno;
				_RefType := 'RDM';
				
				SELECT INTO _StockQty qty FROM poinstock WHERE bpid=_Bpid AND poinruleno = _PoinCode;
				
				IF NOT EXISTS (SELECT 1 FROM poinstock WHERE bpid = _Bpid AND poinruleno = _PoinCode AND poinmodul = _PoinModul) THEN
						_retval.ErrNo:=50001;
						_retval.ErrMsg:='Customer ini tidak memiliki poin '||_PoinCode ||' pada modul poin '||_PoinModul || ' (spRedeem_New)';
		    	    	RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				IF (_Qty > _StockQty) THEN
					_retval.ErrNo:=50001;
					_retval.ErrMsg:='Poin yang anda redeem terlalu besar (spRedeem_New)';
		    	    	RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
				
				SELECT INTO _Cardno * from fTransNoGet('POINCARD');
					IF (_Cardno IS NULL) THEN
		    	    			_retval.ErrNo:=50001;
	                    			_retval.ErrMsg:='Error getting CardNo (spPoinCard_New)';
		    	    		RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				
				INSERT INTO POINCARD 
				Values(_Cardno,_PoinModul, _PoinCode, _Bpid, _RedimDate, _Qty, _RefNo, _Reftype);
				SELECT INTO _spret * FROM spPoinStock_Update(_PoinModul,_Bpid,_PoinCode,_Qty,_RedimDate); 

		
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
		END LOOP;
	
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION spredeem_new(character varying) OWNER TO bits;

CREATE OR REPLACE FUNCTION spredeem_void(_redimno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_Poinmodul		VARCHAR(25);
	_SaleNo			VARCHAR(15);
	_PoinName		VARCHAR(50);
    _RuleNo			VARCHAR(20);
	_Bpid			VARCHAR(15);
	_RefNo			VARCHAR(15);
	_RefType			VARCHAR(10);
	_PoinNo	    VARCHAR(15);
	_CardNo			VARCHAR(15);
	_PoinCode	    VARCHAR(15);
	_RedimDNo		SMALLINT;
	_Qty			NUMERIC(15,4);
	_PrepaidQty		DECIMAL(15,4);
	_PrepaidStockQty	DECIMAL(15,4);
	_Unit			VARCHAR(5);
	_Conv		        DECIMAL(15,4);
	_RedimDate		DATE;
	_Expired		DATE;
	cRedimD 			REFCURSOR;
	cPrepaid 			REFCURSOR;

BEGIN
_retval:=(0, 'OK');   

	OPEN cRedimD FOR
		SELECT  redimdno, poinmodul, poincode, poinname, qty, custid, redimdate
		FROM redimd JOIN redim ON redimd.redimno = redim.redimno
		WHERE redimd.redimno = _Redimno;
		
		LOOP
			FETCH cRedimD INTO _RedimDNo, _PoinModul, _PoinCode, _PoinName, _Qty, _Bpid, _RedimDate;
			EXIT WHEN NOT FOUND;
		
			SELECT INTO _spret * FROM spPoinStock_Update(_PoinModul,_Bpid,_PoinCode,-1*_Qty,_RedimDate);
		       IF _spret.ErrNo<>0 THEN
			  _retval.ErrNo:=_spret.ErrNo;
			  _retval.ErrMsg:=_spret.ErrMsg;
			  RAISE EXCEPTION '%', _retval.ErrMsg;
		      END IF;
		
		END LOOP;
		
		DELETE FROM poincard WHERE refno = _Redimno;
		DELETE FROM redimd WHERE redimno = _Redimno;
		DELETE FROM redim WHERE redimno = _Redimno;
	RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION spredeem_void(character varying)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION spsale_voidpoin(_saleno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE    
    _retval        SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	
	_PoinNo					VARCHAR;
	
    cCursor        REFCURSOR;
BEGIN

		SELECT  INTO _spret * FROM  spPoin_VoidFromSale(_saleno);
		
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		SELECT  INTO _spret * FROM  spSale_Void(_saleno);
		
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
		
		
		
    _retval:=(0,'OK');
    RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION spsale_voidpoin(character varying)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION sppadj_new(_PAdjNo character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_PAdjDNo		SMALLINT;
	_PoinModul		VARCHAR(25);
	_PoinCode		VARCHAR(15);
	_PoinName		VARCHAR(50);
	_RefType		VARCHAR(5);
	_CardDate		DATE;
	_BpId			VARCHAR(15);
	_CardQty		NUMERIC(15,4);		
	_CardNo			VARCHAR(15);
	cPAdj 		REFCURSOR;
BEGIN
	_retval:=(0, 'OK');

	OPEN cPAdj FOR

		SELECT  padjdno, poinmodul, poincode, poinname
		FROM padjd
		WHERE padjno = _PAdjNo;

		LOOP
			FETCH cPAdj INTO _PAdjDNo, _PoinModul, _PoinCode, _PoinName;
			EXIT WHEN NOT FOUND;
				
			SELECT INTO _Reftype padjtype FROM padj WHERE padjno = _PAdjNo;
			SELECT INTO _CardDate padjdate FROM padj WHERE padjno = _PAdjNo;
			SELECT INTO _Bpid bpid FROM padj WHERE padjno = _PAdjNo;
			SELECT INTO _CardQty qty FROM padjd WHERE poinmodul=_PoinModul AND poincode = _PoinCode AND padjno = _PAdjNo;
	
		SELECT INTO _Cardno * FROM fTransNoGet('POINCARD');
			IF (_Cardno IS NULL) THEN
		     	_retval.ErrNo:=50001;
	            _retval.ErrMsg:='Error getting CardNo (spPoinCard_New)';
		    	RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
					
		INSERT INTO POINCARD VALUES(_Cardno,_PoinModul, _PoinCode, _Bpid, _CardDate, _CardQty, _PAdjNo, _Reftype);			
	
		IF NOT EXISTS (SELECT 1 FROM poinstock WHERE poinmodul=_PoinModul AND bpid=_Bpid AND poinruleno=_PoinCode) THEN
		
			INSERT INTO PoinStock(poinmodul,poinruleno,bpid, qty, active) VALUES(_PoinModul,_PoinCode,_Bpid,_CardQty, TRUE);

			SELECT INTO _spret * FROM spPoinBal_Update(_PoinModul,_PoinCode,_Bpid,_CardQty,_CardDate); 
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
		ELSE
			SELECT INTO _spret * FROM spPoinStock_Update(_PoinModul,_Bpid,_PoinCode,-1*_CardQty,_CardDate); 			
		END IF;
	END LOOP;
	CLOSE cPAdj;
	
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppadj_new(character varying) OWNER TO bits;CREATE OR REPLACE FUNCTION sppadj_void(_padjno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_PAdjDNo		SMALLINT;
	_PoinModul		VARCHAR(25);
	_PoinCode		VARCHAR(15);
	_PoinName		VARCHAR(50);
	_RefType		VARCHAR(5);
	_CardDate		DATE;
	_BpId			VARCHAR(15);
	_CardQty		NUMERIC(15,4);		
	_CardNo			VARCHAR(15);
	cPAdj 			REFCURSOR;
	
BEGIN
	_retval:=(0, 'OK');

	OPEN cPAdj FOR

		SELECT  padjdno, poinmodul, poincode, poinname
		FROM padjd
		WHERE padjno = _PAdjNo;

		LOOP
			FETCH cPAdj INTO _PAdjDNo, _PoinModul, _PoinCode, _PoinName;
			EXIT WHEN NOT FOUND;
				
			SELECT INTO _CardDate padjdate FROM padj WHERE padjno = _PAdjNo;
			SELECT INTO _Bpid bpid FROM padj WHERE padjno = _PAdjNo;
			SELECT INTO _CardQty qty FROM padjd WHERE poinmodul=_PoinModul AND poincode = _PoinCode AND padjno = _PAdjNo;
			
			SELECT INTO _spret * FROM spPoinStock_Update(_PoinModul, _Bpid, _PoinCode, _CardQty, _CardDate); 

				IF _spret.ErrNo<>0 THEN
				   _retval.ErrNo:=_spret.ErrNo;
				   _retval.ErrMsg:=_spret.ErrMsg;
				   RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
				
	END LOOP;
	CLOSE cPAdj;
	
	DELETE FROM padjd WHERE padjno = _padjno;
	DELETE FROM padj WHERE padjno = _padjno;
	DELETE FROM poincard WHERE refno = _PAdjno;
	
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppadj_void(character varying) OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoincard_new(_poinno character varying, _action character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	_Cardno			VARCHAR(15);
	_ModulName		VARCHAR(20);
	_Bpid			VARCHAR(15);
	_CardDate		DATE;		
	_PoinDate		DATE;
	_CardQty		NUMERIC(15,4);			
	_PoinDNo		SMALLINT;
	_PoinRuleNo	    	VARCHAR(15);
	_PoinCode	    	VARCHAR(15);
	_CardQtyIndex		INTEGER;
	_PoinName		VARCHAR(50);
	_QtyPoin		NUMERIC(15,4);
	_saledno		SMALLINT;
	_RefNo			VARCHAR(15);
	_Reftype		VARCHAR(5);
	_Conv		    	DECIMAL(15,4);
	_Expired		DATE;
	cPoinD 			REFCURSOR;

BEGIN
	_retval:=(0, 'OK');

	OPEN cPoinD FOR

		SELECT  poindno, poincode, poinname, qtypoin, expaired, poinmodul, poindate
		FROM Poind
		WHERE poinno = _PoinNo;

		LOOP
			FETCH cPoinD INTO  _PoinDNo, _PoinCode, _PoinName, _QtyPoin, _Expired, _ModulName,_PoinDate;
			EXIT WHEN NOT FOUND;
		
			
			
			SELECT INTO _RefNo refno FROM poin WHERE poinno = _PoinNo;
			SELECT INTO _Reftype reftype FROM poin WHERE poinno = _PoinNo;
			SELECT INTO _CardDate poindate FROM poin WHERE poinno = _PoinNo;
			SELECT INTO _Bpid custid FROM poin WHERE poinno = _PoinNo;
			SELECT INTO _CardQty qtypoin FROM poind WHERE poinmodul=_ModulName AND poincode = _PoinCode AND poinno = _PoinNo;

			SELECT INTO _Cardno * from fTransNoGet('POINCARD');
					IF (_Cardno IS NULL) THEN
		    	    			_retval.ErrNo:=50001;
	                    			_retval.ErrMsg:='Error getting CardNo (spPoinCard_New)';
		    	    		RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;

			INSERT INTO POINCARD 
			Values(_Cardno,_ModulName, _PoinCode, _Bpid, _CardDate, _CardQty,_RefNo,_Reftype);

			

			IF(_Action='NEW') THEN
				SELECT INTO _CardQtyIndex Cast(_CardQty As INTEGER);
				
			 	IF NOT EXISTS
					(SELECT 1 FROM poinstock WHERE poinmodul=_ModulName AND bpid=_Bpid AND poinruleno=_PoinCode) THEN
					

					SELECT INTO _spret * FROM 
					spPoinStock_New(_PoinNo,_PoinDNo,_ModulName,_Bpid,_CardQtyIndex,_PoinCode); 

					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSE
					SELECT INTO _spret * FROM spPoinStock_Update(_ModulName,_Bpid,_PoinCode,-1*_CardQty,_PoinDate); 			
				END IF;

				
			ELSEIF(_ACTION='USE') THEN

				SELECT INTO _spret * FROM spPoinStock_Update(_ModulName,_Bpid,_PoinCode,_CardQty,_PoinDate); 

				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;
		END LOOP;

	CLOSE cPoinD;

RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoincard_new(character varying, character varying)
  OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoincard_void(_poinno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			 SPStatus%ROWTYPE;
	_spret			 SPStatus%ROWTYPE;
	_ModulName		 VARCHAR(20);
	_SaleNo			 VARCHAR(15);
	_PoinName		 VARCHAR(50);
    _RuleNo			 VARCHAR(20);
	_Bpid			 VARCHAR(15);
	_PoinCode	     VARCHAR(15);
	_PoinDNo		 SMALLINT;
	_CardQty		 DECIMAL(15,4);
	_PrepaidQty		 DECIMAL(15,4);
	_PrepaidStockQty DECIMAL(15,4);
	_Unit			 VARCHAR(5);
	_Conv		     DECIMAL(15,4);
	_PoinDate		 DATE;
	_Expired		 DATE;
	cPoinD 			 REFCURSOR;
	cPrepaid 		 REFCURSOR;

BEGIN
	_retval:=(0, 'OK');

	
	   OPEN cPoinD FOR
		SELECT  poindno, poincode, poinname, qtypoin, expaired, poinmodul, poindate
		FROM Poind
		WHERE poinno = _PoinNo;
		
		
		LOOP
		FETCH cPoinD INTO _PoinDNo, _PoinCode, _PoinName, _CardQty, _Expired, _ModulName,_PoinDate;
		EXIT WHEN NOT FOUND;
				
				SELECT INTO _SaleNo saleno FROM poinsale WHERE poinno = _poinno;
				SELECT INTO _Bpid custid FROM poin WHERE poinno = _PoinNo;
				
				SELECT INTO _spret * FROM spPoinStock_Update(_ModulName,_Bpid,_PoinCode,_CardQty,_PoinDate); 

				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
		END LOOP;
        					
		DELETE FROM Poincard WHERE refno = _Saleno;		
	
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION sppoincard_void(character varying)
  OWNER TO bits;

-- Function: spsret_void(character varying)

-- DROP FUNCTION spsret_void(character varying);

CREATE OR REPLACE FUNCTION spsret_void(_sretno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval		SPStatus%ROWTYPE;
	_spret		SPStatus%ROWTYPE;

	_CustID		VARCHAR(15);
	_ConsNo		VARCHAR(15);
	_TermType		VARCHAR(1);
	_IsContra	BOOLEAN;
	_JnlNo		VARCHAR(15);
	_regval		VARCHAR(30);

	_itemid		VARCHAR(20);
	_qty		NUMERIC(15,4);
	_qtyx		NUMERIC(15,4);
	_unit		VARCHAR(5);
	_qtysret	NUMERIC(15,4);
	cSretD		refcursor;

	_DeliNo		VARCHAR(15);
	cSRetDeli	REFCURSOR;

	_SRetStatus	VARCHAR(1);
	_PID		VARCHAR;
	
	_isDraft	BOOLEAN;
	_SRetDate	DATE;
	_LockDate	DATE;
BEGIN
	SELECT into _CustID, _TermType, _IsContra, _ConsNo, _SRetStatus, _SRetDate
		    CustID, TermType, IsContra, ConsNo, SRetStatus, SRetDate
	FROM SRet
	WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_retval.ErrNo:=50001;
		_retval.ErrMsg:='Retur/Memo-Piutang #'||_SRetNo||' tidak ditemukan (spSRet_Void)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _LockDate lockdate FROM TLock WHERE TransType='SRET';
	IF(_LockDate is not null AND _LockDate>_SRetDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Retur Melebihi Batas Tanggal Kunci Transaksi !';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF ((_TermType='R') AND (_IsContra=true)) THEN /*--(_SRetStatus<>'N')) THEN*/
		_retval.ErrNo:=50002;
		_retval.ErrMsg:='Retur/Memo-Piutang sudah dipotongkan pembayaran Hutang, VOID dulu pembayarannya ! (spSRet_Void)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	/** CEK ISDRAFT */
	SELECT INTO _isDraft IsDraft FROM SRet WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_isDraft:=FALSE;
	END IF;

	IF (_isDraft IS NULL) THEN
		_isDraft:=FALSE;
	END IF;
	
	IF (_isDraft=FALSE) THEN /** MULAI ISDRAFT */

	OPEN cSRetDeli FOR
	SELECT DeliNo FROM SRetDeli WHERE SRetNo=_SRetNo;
	LOOP
		FETCH cSRetDeli INTO _DeliNo;
		EXIT WHEN NOT FOUND;
		UPDATE Deli SET isinvoiced=false WHERE DeliNo=_DeliNo;
		DELETE FROM SRetDeli WHERE DeliNo=_DeliNo AND SRetNo=_SRetNo;
	END LOOP;
	CLOSE cSRetDeli;

	SELECT into _spret * FROM spStockA_Void_byRef('SRET', _SRetNo);
	IF _spret.ErrNo<>0 THEN
		_retval.ErrNo:=_spret.ErrNo;
		_retval.ErrMsg:=_spret.ErrMsg;
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_TermType='C') THEN
		SELECT into _spret * FROM spCashA_Void_byRef('SRET', _SRetNo,null,null);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;			
		END IF;
	ELSE
		IF (_ConsNo IS NOT NULL) THEN	
			/** do nothing, khan saat new nggak bikin bpa */
		ELSE		
			SELECT into _spret * FROM spBPA_Void_byRef('SRET', _SretNo);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;
	END IF;

	IF (_ConsNo IS NOT NULL) THEN
		OPEN cSretD FOR
			SELECT itemid, qty, qtyx, PID, unit from sretd where sretno=_SRetNo;
			LOOP
				FETCH cSretD INTO _itemid, _qty, _qtyx, _PID, _unit;
				EXIT WHEN NOT FOUND;
				_qtysret:=fQtyZToQty1(_itemid,_qty,_unit);
				IF (_PID IS NULL) THEN
				UPDATE consd set qtycret=qtycret-_qtysret, qtyxcret=qtyxcret-_qtyx WHERE consno=_consno AND itemid=_itemid;
				ELSE
				UPDATE consd set qtycret=qtycret-_qtysret, qtyxcret=qtyxcret-_qtyx WHERE consno=_consno AND itemid=_itemid AND PID=_PID;
				END IF;
			END LOOP;
		CLOSE cSretD;

		SELECT INTO _spret * FROM spSetConsStatus(_ConsNo);
		IF _spret.ErrNO<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;	

	END IF; /** END IF ISDRAFT */

	IF (isAccInstalled() AND _isDraft=FALSE) THEN
		SELECT into _spret * from spJnl_Void_byRef('SRET',_SRetNo);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;
		
	DELETE FROM SRetD WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg:='Error Delete SRetD (spSRet_Void)';
	END IF;
	
	DELETE FROM SRet WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_retval.ErrNo:=50004;
		_retval.ErrMsg:='Error Delete SRet (spSRet_Void)';
	END IF;	
	SELECT  INTO _spret * FROM  spPoin_VoidFromSret(_sretno);
		
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION spsret_void(character varying) OWNER TO bits;

-- Function: spSret_VoidPoin(character varying)

-- DROP FUNCTION spSret_VoidPoin(character varying);

CREATE OR REPLACE FUNCTION spSret_VoidPoin(_sretno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval		SPStatus%ROWTYPE;
	_spret		SPStatus%ROWTYPE;

	_CustID		VARCHAR(15);
	_ConsNo		VARCHAR(15);
	_TermType		VARCHAR(1);
	_IsContra	BOOLEAN;
	_JnlNo		VARCHAR(15);
	_regval		VARCHAR(30);

	_itemid		VARCHAR(20);
	_qty		NUMERIC(15,4);
	_qtyx		NUMERIC(15,4);
	_unit		VARCHAR(5);
	_qtysret	NUMERIC(15,4);
	cSretD		refcursor;

	_DeliNo		VARCHAR(15);
	cSRetDeli	REFCURSOR;

	_SRetStatus	VARCHAR(1);
	_PID		VARCHAR;
	
	_isDraft	BOOLEAN;
	_SRetDate	DATE;
	_LockDate	DATE;
BEGIN
	SELECT into _CustID, _TermType, _IsContra, _ConsNo, _SRetStatus, _SRetDate
		    CustID, TermType, IsContra, ConsNo, SRetStatus, SRetDate
	FROM SRet
	WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_retval.ErrNo:=50001;
		_retval.ErrMsg:='Retur/Memo-Piutang #'||_SRetNo||' tidak ditemukan (spSRet_Void)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _LockDate lockdate FROM TLock WHERE TransType='SRET';
	IF(_LockDate is not null AND _LockDate>_SRetDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Retur Melebihi Batas Tanggal Kunci Transaksi !';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF ((_TermType='R') AND (_IsContra=true)) THEN /*--(_SRetStatus<>'N')) THEN*/
		_retval.ErrNo:=50002;
		_retval.ErrMsg:='Retur/Memo-Piutang sudah dipotongkan pembayaran Hutang, VOID dulu pembayarannya ! (spSRet_Void)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	/** CEK ISDRAFT */
	SELECT INTO _isDraft IsDraft FROM SRet WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_isDraft:=FALSE;
	END IF;

	IF (_isDraft IS NULL) THEN
		_isDraft:=FALSE;
	END IF;
	
	IF (_isDraft=FALSE) THEN /** MULAI ISDRAFT */

	OPEN cSRetDeli FOR
	SELECT DeliNo FROM SRetDeli WHERE SRetNo=_SRetNo;
	LOOP
		FETCH cSRetDeli INTO _DeliNo;
		EXIT WHEN NOT FOUND;
		UPDATE Deli SET isinvoiced=false WHERE DeliNo=_DeliNo;
		DELETE FROM SRetDeli WHERE DeliNo=_DeliNo AND SRetNo=_SRetNo;
	END LOOP;
	CLOSE cSRetDeli;

	SELECT into _spret * FROM spStockA_Void_byRef('SRET', _SRetNo);
	IF _spret.ErrNo<>0 THEN
		_retval.ErrNo:=_spret.ErrNo;
		_retval.ErrMsg:=_spret.ErrMsg;
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_TermType='C') THEN
		SELECT into _spret * FROM spCashA_Void_byRef('SRET', _SRetNo,null,null);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;			
		END IF;
	ELSE
		IF (_ConsNo IS NOT NULL) THEN	
			/** do nothing, khan saat new nggak bikin bpa */
		ELSE		
			SELECT into _spret * FROM spBPA_Void_byRef('SRET', _SretNo);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;
	END IF;

	IF (_ConsNo IS NOT NULL) THEN
		OPEN cSretD FOR
			SELECT itemid, qty, qtyx, PID, unit from sretd where sretno=_SRetNo;
			LOOP
				FETCH cSretD INTO _itemid, _qty, _qtyx, _PID, _unit;
				EXIT WHEN NOT FOUND;
				_qtysret:=fQtyZToQty1(_itemid,_qty,_unit);
				IF (_PID IS NULL) THEN
				UPDATE consd set qtycret=qtycret-_qtysret, qtyxcret=qtyxcret-_qtyx WHERE consno=_consno AND itemid=_itemid;
				ELSE
				UPDATE consd set qtycret=qtycret-_qtysret, qtyxcret=qtyxcret-_qtyx WHERE consno=_consno AND itemid=_itemid AND PID=_PID;
				END IF;
			END LOOP;
		CLOSE cSretD;

		SELECT INTO _spret * FROM spSetConsStatus(_ConsNo);
		IF _spret.ErrNO<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;	

	END IF; /** END IF ISDRAFT */

	IF (isAccInstalled() AND _isDraft=FALSE) THEN
		SELECT into _spret * from spJnl_Void_byRef('SRET',_SRetNo);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;
		
	DELETE FROM SRetD WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg:='Error Delete SRetD (spSRet_Void)';
	END IF;
	
	DELETE FROM SRet WHERE SRetNo=_SRetNo;
	IF NOT FOUND THEN
		_retval.ErrNo:=50004;
		_retval.ErrMsg:='Error Delete SRet (spSRet_Void)';
	END IF;	
	SELECT  INTO _spret * FROM  spPoin_VoidFromSret(_sretno);
		
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION spsret_voidpoin(character varying) OWNER TO bits;

CREATE OR REPLACE FUNCTION sppoinsretcard_void(_poinno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			 SPStatus%ROWTYPE;
	_spret			 SPStatus%ROWTYPE;
	_ModulName		 VARCHAR(20);
	_SretNo			 VARCHAR(15);
	_PoinName		 VARCHAR(50);
        _RuleNo			 VARCHAR(20);
	_Bpid			 VARCHAR(15);
	_PoinCode	     VARCHAR(15);
	_PoinDNo		 SMALLINT;
	_CardQty		 DECIMAL(15,4);
	_PrepaidQty		 DECIMAL(15,4);
	_PrepaidStockQty DECIMAL(15,4);
	_Unit			 VARCHAR(5);
	_Conv		     DECIMAL(15,4);
	_PoinDate		 DATE;
	_Expired		 DATE;
	cPoinD 			 REFCURSOR;
	cPrepaid 		 REFCURSOR;

BEGIN
	_retval:=(0, 'OK');

	
	   OPEN cPoinD FOR
		SELECT  poindno, poincode, poinname, qtypoin, expaired, poinmodul, poindate
		FROM Poind
		WHERE poinno = _PoinNo;
		
		
		LOOP
		FETCH cPoinD INTO _PoinDNo, _PoinCode, _PoinName, _CardQty, _Expired, _ModulName,_PoinDate;
		EXIT WHEN NOT FOUND;
				
				SELECT INTO _SretNo sretno FROM poinsret WHERE poinno = _poinno;
				SELECT INTO _Bpid custid FROM poin WHERE poinno = _PoinNo;
				
				
				

				SELECT INTO _spret * FROM spPoinStock_Update(_ModulName,_Bpid,_PoinCode,-1*_CardQty,_PoinDate); 

				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
		END LOOP;
        
		
					
		DELETE FROM Poincard WHERE refno = _Sretno;		
	
RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;

CREATE OR REPLACE FUNCTION sppoin_voidfromsret(_sretno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE    
    _retval        SPStatus%ROWTYPE;
		_spret			SPStatus%ROWTYPE;
	_PoinNo					VARCHAR;
	
    cCursor        REFCURSOR;
BEGIN

		SELECT INTO _PoinNo poinno FROM poinsret WHERE sretno = _SretNo;

		SELECT INTO _spret * FROM sppoinsretcard_void(_PoinNo); 
		      IF _spret.ErrNo<>0 THEN
			  _retval.ErrNo:=_spret.ErrNo;
			  _retval.ErrMsg:=_spret.ErrMsg;
			  RAISE EXCEPTION '%', _retval.ErrMsg;
		      END IF;
		
		DELETE FROM poinsret WHERE poinno = _PoinNo;
		DELETE FROM poind WHERE poinno = _PoinNo;
		DELETE FROM poin WHERE poinno = _PoinNo;
		
		
		
    _retval:=(0,'OK');
    RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;

CREATE OR REPLACE FUNCTION sppoinsret_new(_poinno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE    
    _retval        SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	
	_ModulName		VARCHAR(25);
	__ruleno		VARCHAR(15);
	_CustId			VARCHAR(15);
	_RefNo			VARCHAR;
	
    cCursor        REFCURSOR;
BEGIN
		
		SELECT INTO _RefNo refno FROM poin WHERE poinno = _PoinNo;
		SELECT INTO _CustId custid FROM poin WHERE poinno = _PoinNo;
		SELECT INTO _ModulName poinmodul FROM poind WHERE poinno = _PoinNo;
		SELECT INTO __ruleno poincode FROM poind WHERE poinno = _PoinNo;
		
		INSERT INTO poinsret (poinno, sretno) VALUES (_PoinNo,_RefNo);

		SELECT INTO _spret * FROM spPoinCard_New(_PoinNo, 'USE'); 
		       IF _spret.ErrNo<>0 THEN
			  _retval.ErrNo:=_spret.ErrNo;
			  _retval.ErrMsg:=_spret.ErrMsg;
			  RAISE EXCEPTION '%', _retval.ErrMsg;
		      END IF;
		
	_retval:=(0,'OK');
    RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;

INSERT INTO rpar VALUES ('SALE', 'CURRENTPOINTOTAL', '5', '2', 'com.bits.bee.poincore.bl.PoinSaleList.getInstance().getCurrentTotal(A)', 'L', 'Poin yang didapat');
INSERT INTO rpar VALUES ('SALE', 'POINTOTAL', '5', '2', 'com.bits.bee.poincore.bl.PoinSaleList.getInstance().getTotal(A)', 'L', 'Total Poin');
INSERT INTO rband VALUES ('SALE', (SELECT MAX(rowno) FROM rband) + 1, 'SUMMARY', '$0F4. Poin yang anda peroleh sebanyak ^CURRENTPOINTOTAL......................', NULL);
INSERT INTO rband VALUES ('SALE', (SELECT MAX(rowno) FROM rband) + 1, 'SUMMARY', '$0F5. Saldo poin anda sekarang ^POINTOTAL.....................', NULL);

INSERT INTO rpar VALUES ('POS', 'CURRENTPOINTOTAL', '5', '2', 'com.bits.bee.poincore.bl.PoinSaleList.getInstance().getCurrentTotal(A)', 'L', 'Poin yang didapat');
INSERT INTO rpar VALUES ('POS', 'POINTOTAL', '5', '2', 'com.bits.bee.poincore.bl.PoinSaleList.getInstance().getTotal(A)', 'L', 'Total Poin');
INSERT INTO rband VALUES ('POS', (SELECT MAX(rowno) FROM rband) + 1, 'SUMMARY', '$0F::Poin yang anda peroleh sebanyak ^CURRENTPOINTOTAL......::$12', NULL);
INSERT INTO rband VALUES ('POS', (SELECT MAX(rowno) FROM rband) + 1, 'SUMMARY', '$0F::Saldo poin anda sekarang ^POINTOTAL......::$12', NULL);

/*===================STANDART==============================*/

-- modul --
INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('950000','ROOT','MST','Poin Rule',1,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('950001','950000','MST','Daftar Poin Total Faktur',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('950002','950000','MST','Poin Total Faktur',2,true);
	
-- default privilege --
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950000', 'ENB', true);
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950000', 'OPN', true);
	-- Daftar Poin Total Faktur
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'NEW', true);
	-- Poin Total Faktur
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'NEW', true);

-- group privilege --
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('950000');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('950001');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('950002');
		
/*===================CORE==============================*/

-- modul --
INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970000','ROOT','MST','Poin Core',1,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970001','970000','MST','Cek Poin',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970002','970000','MST','Sub Penggunaan Poin',2,true);
		INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970021','970002','MST','Daftar Penggunaan Poin',3,true);
		INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970022','970002','MST','Penggunaan Poin',3,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970003','970000','MST','Saldo Poin',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970004','970000','MST','Laporan Poin Stock',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970005','970000','MST','Laporan Kartu Stock Poin',2,true);
	
-- default privilege --
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970000', 'ENB', true);
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970000', 'OPN', true);
	-- Cek Poin	
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'NEW', true);
	-- Sub Penggunaan Poin
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'NEW', true);
		-- Daftar Penggunaan Poin
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'ENB', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'OPN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'UPD', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'DEL', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'PRN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'VOI', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'NEW', true);
		-- Penggunaan Poin
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'ENB', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'OPN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'UPD', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'DEL', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'PRN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'VOI', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'NEW', true);				
	-- Saldo Poin
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'NEW', true);
	-- Laporan Poin Stock
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'NEW', true);
	-- Laporan Kartu Stock Poin
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'NEW', true);

-- group privilege --
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970000');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970001');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970002');
	INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970021');
	INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970022');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970003');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970004');
INSERT INTO grpprv (grpid, objid, acstype, acsval, acsenable) SELECT 'ADM',objid,acstype,acsval,true FROM objacl WHERE objid IN ('970005');
/*===================STANDART==============================*/

-- modul --
INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('950000','ROOT','MST','Poin Rule',1,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('950001','950000','MST','Daftar Poin Total Faktur',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('950002','950000','MST','Poin Total Faktur',2,true);
	
-- privilege --
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950000', 'ENB', true);
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950000', 'OPN', true);
	-- Daftar Poin Total Faktur
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950001', 'NEW', true);
	-- Poin Total Faktur
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('950002', 'NEW', true);
		
/*===================CORE==============================*/

-- modul --
INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970000','ROOT','MST','Poin Core',1,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970001','970000','MST','Cek Poin',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970002','970000','MST','Sub Penggunaan Poin',2,true);
		INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970021','970002','MST','Daftar Penggunaan Poin',3,true);
		INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970022','970002','MST','Penggunaan Poin',3,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970003','970000','MST','Saldo Poin',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970004','970000','MST','Laporan Poin Stock',2,true);
	INSERT INTO obj(objid,upobjid,modulid,objname,objlevel,enabled) VALUES('970005','970000','MST','Laporan Kartu Stock Poin',2,true);
	
-- privilege --
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970000', 'ENB', true);
INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970000', 'OPN', true);
	-- Cek Poin	
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970001', 'NEW', true);
	-- Sub Penggunaan Poin
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970002', 'NEW', true);
		-- Daftar Penggunaan Poin
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'ENB', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'OPN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'UPD', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'DEL', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'PRN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'VOI', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970021', 'NEW', true);
		-- Penggunaan Poin
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'ENB', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'OPN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'UPD', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'DEL', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'PRN', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'VOI', true);
		INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970022', 'NEW', true);				
	-- Saldo Poin
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970003', 'NEW', true);
	-- Laporan Poin Stock
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970004', 'NEW', true);
	-- Laporan Kartu Stock Poin
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'ENB', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'OPN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'UPD', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'DEL', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'PRN', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'VOI', true);
	INSERT INTO OBJACL (objid, acstype, acsenable) VALUES('970005', 'NEW', true);
